package net.pterodactylus.sone.database;

import java.util.Collection;

import net.pterodactylus.sone.data.Client;
import net.pterodactylus.sone.data.LocalSone;
import net.pterodactylus.sone.data.Post;
import net.pterodactylus.sone.data.PostReply;
import net.pterodactylus.sone.data.Sone;
import net.pterodactylus.sone.freenet.wot.Identity;

/**
 * Builder for {@link Sone} objects.
 *
 * @author <a href="mailto:bombe@pterodactylus.net">David ‘Bombe’ Roden</a>
 */
public interface SoneBuilder {

	SoneBuilder from(Identity identity);

	SoneBuilder lastUpdated(long lastUpdated);
	SoneBuilder using(Client client);

	SoneBuilder withPosts(Collection<Post> posts);
	SoneBuilder withPostReplies(Collection<PostReply> postReplies);

	Sone build() throws IllegalStateException;
	LocalSone buildLocal() throws IllegalStateException;

}
