package net.pterodactylus.sone.database.memory;

import net.pterodactylus.sone.data.LocalSone;
import net.pterodactylus.sone.data.Sone;
import net.pterodactylus.sone.data.impl.AbstractSoneBuilder;
import net.pterodactylus.sone.data.impl.SoneImpl;
import net.pterodactylus.sone.database.Database;
import net.pterodactylus.sone.freenet.wot.OwnIdentity;

import com.google.common.base.Preconditions;

/**
 * Memory-based {@link AbstractSoneBuilder} implementation.
 *
 * @author <a href="mailto:bombe@pterodactylus.net">David ‘Bombe’ Roden</a>
 */
public class MemorySoneBuilder extends AbstractSoneBuilder {

	private final Database database;

	public MemorySoneBuilder(Database database) {
		this.database = database;
	}

	@Override
	public Sone build() throws IllegalStateException {
		validate();
		return new SoneImpl(database, identity, false, lastUpdated, client, posts, postReplies);
	}

	@Override
	public LocalSone buildLocal() throws IllegalStateException {
		validateLocal();
		return new SoneImpl(database, identity, true, lastUpdated, client, posts, postReplies);
	}

}
